% July 1999 / Angela Nebot
%
% Example that reproduces the results obtained in the identification of
% a anaesthetic agent controller. data obtained from Unv. of Sheffield. Patient JM0.
% 
%
%
echo on;
%
% Global variables
%
global qualms repo confi memb_shape miss_data meth_search def abs_weight distance envol norm_reg valida_dat;
def = 1;
abs_weight =1;
norm_reg = 2;
meth_search = 1;
memb_shape=0;
qualms = 1;
repo = 0;
confi = 0;
distance=1;
envol=0;
miss_data=1000;
valida_dat=1;
%
%
% Load of the data (we have interpolated the data in order to get
% more data points). Initially we had 163 points and after the interpolation
% we have 325. 
%
%
load jm0s
%
meas = sapi';
meas = [meas , hr1i'];
meas = [meas , rri'];
meas = [meas , dosei'];
%
%  Recode of the data registered from the system%
%
m = meas;
for i=1:4,
  [mi,indx] = sort(meas(:,i));
  m(:,i) = mi;
end


lm = [ m(1,:)
       0.5*(m(108,:) + m(109,:))
       0.5*(m(216,:) + m(217,:))
       m(325,:) ];

lmrr = [ m(1,3)
       0.5*(m(162,3) + m(163,3))
       m(325,3) ];

to = 1:3;
raw1 = meas;  memb1 = meas;  side1 = meas;
for i=1:2,
  from = [ lm(1:3,i) , lm(2:4,i) ]';
  [r,m,s] = recode(meas(:,i),from,to);
  raw1(:,i) = r;  memb1(:,i) = m;  side1(:,i) = s;
end

to = 1:3;
  from = [ lm(1:3,4) , lm(2:4,4) ]';
  [r,m,s] = recode(meas(:,4),from,to);
  raw1(:,4) = r;  memb1(:,4) = m;  side1(:,4) = s;


to = 1:2;
  from = [ lmrr(1:2,1) , lmrr(2:3,1) ]';
  [r,m,s] = recode(meas(:,3),from,to);
  raw1(:,3) = r;  memb1(:,3) = m;  side1(:,3) = s;
%  
rraw = raw1(1:270,:);
mmemb = memb1(1:270,:);
sside = side1(1:270,:);
mcan  = 0 * ones(21,4);
mcan(1,:) = [-1 -1 -1 -1];
mcan(11,:) = [-1 -1 -1 -1];
mcan(21,:) = [-1 -1 -1 +1];
mcan;
[mask,hm,hr,q,mhis] = mexfoptmask(rraw,mmemb,mcan,5);
%
%
% Prediction of the output variable
%
%
[io, mio, sio] = iomodel(rraw,mmemb,sside,mask);
[b1a,mb1a,sb1a] = behavior(io,mio,sio);
f1 = raw1(251:325, :);
m1 = memb1(251:325, :);
s1 = side1(251:325, :);
f1(21:75,4) = zeros(55,1);
m1(21:75,4) = 0.75*ones(55,1);
s1(21:75,4) = ones(55,1);
alm=[3 3 2 3];
[f2, m2, s2] = forecast(f1,m1,s1,b1a,mb1a,sb1a,mask,alm);
%
simdat = raw1(271:325,4);
frcdat = f2(21:75,4);
[simdat frcdat]
%
%
%  Regeneration of the predicted data
%
%
mfrcdat = m2(21:75,:);
sfrcdat = s2(21:75,:);
frcdat  = f2(21:75,:);
rmeas = meas(271:325,:);
from = 1:3;
to = [ lm(1:3,4) , lm(2:4,4) ]';
  rm = regenerate(frcdat(:,4), mfrcdat(:,4), sfrcdat(:,4),from,to);
  rmeas(:,4) = rm; 
%
y1 = meas(271:325,4);
y2 = rmeas(:,4);
[y1 y2]
echo off;
plot([y1 y2]);
pause
%

